dofile ("data/zero/zero.lua")

local entity_id = GetUpdatedEntityID()
local zmath = Z:Utils()
local component = EntityGetFirstComponent(entity_id, "DamageModelComponent")
local max_hp = ComponentGetValue(component, "max_hp") * 25
local hp = ComponentGetValue(component, "hp") * 25

function numeric_sprite(hp, offset_y, is_percent)
    local numeric_bar = EntityGetFirstComponent(entity_id, "SpriteComponent", "numeric_bar")
    
    if numeric_bar ~= nil then
        local hp2 = tostring(ComponentGetValue(numeric_bar, "text"))
        hp2 = string.gsub(hp2, '%%', '')
        if tostring(hp) ~= tostring(hp2) then
            EntityRemoveComponent(entity_id, numeric_bar)
        end
    else
        if hp > 0.04 and hp < 1 then hp = 1 end
        
        hp = string.format("%d", hp)
        if is_percent then
            hp = hp .. '%'
        end
        EntityAddComponent(entity_id, "SpriteComponent",
        {
            _tags="numeric_bar",
            has_special_scale="1",
            image_file="data/fonts/default.xml",
            is_text_sprite="1",
            next_rect_animation="",
            offset_x=(#hp * 2),
            offset_y=offset_y,
            rect_animation="",
            ui_is_parent="0",
            update_transform="1",
            visible="1",
            alpha="1",
            z_index="-10000",
            text=hp,
        });
    end
end

if EntityHasTag(entity_id, 'player_unit') then
    if HasFlagPersistent('hp_player_num') == false and HasFlagPersistent('hp_player_percent') == false then
        -- не отображаем значение, если выключены все опции
    else
        hp = zmath.round(HasFlagPersistent('hp_player_percent') and hp / max_hp * 100 or hp) -- проценты
        is_percent = false
        offset_y = -4
        if HasFlagPersistent('hp_player_bar') and (HasFlagPersistent('hp_player_num') or HasFlagPersistent('hp_player_percent')) then
            offset_y = -7
        end
        if HasFlagPersistent('hp_player_percent') then
            is_percent = true
        end
        numeric_sprite(hp, offset_y, is_percent)
    end
else
    if HasFlagPersistent('hp_enemy_num') == false and HasFlagPersistent('hp_enemy_percent') == false then
        -- не отображаем значение, если выключены все опции
    else
        hp = zmath.round(HasFlagPersistent('hp_enemy_percent') and hp / max_hp * 100 or hp) -- проценты
        is_percent = false
        offset_y = -4
        if HasFlagPersistent('hp_enemy_bar') and (HasFlagPersistent('hp_enemy_num') or HasFlagPersistent('hp_enemy_percent')) then
            offset_y = -7
        end
        if HasFlagPersistent('hp_enemy_percent') then
            is_percent = true
        end
        numeric_sprite(hp, offset_y, is_percent)
    end
    
end

