dofile ("data/zero/zero.lua")

player = Z:Entity('player_unit')[1]


-- отрисовка здоровья для игрока
function player_bar_enable()
    if HasFlagPersistent('hp_player_bar') then
        player.component("sprite_bar", "LuaComponent", "script_source_file", "data/scripts/bars/sprite_bar.lua")
        player.component("sprite_bar", "LuaComponent", "execute_every_n_frame", "1")
    end
end

function player_bar_disable()
    EntityRemoveComponent(player.id(), EntityGetFirstComponent(player.id(), 'HealthBarComponent'))
    EntityRemoveComponent(player.id(), EntityGetFirstComponent(player.id(), 'SpriteComponent', 'health_bar'))
    EntityRemoveComponent(player.id(), EntityGetFirstComponent(player.id(), 'SpriteComponent', 'health_bar_bg'))
    EntityRemoveComponent(player.id(), EntityGetFirstComponent(player.id(), 'LuaComponent', 'sprite_bar'))
end


function player_num_enable()
    if HasFlagPersistent('hp_player_num') or HasFlagPersistent('hp_player_percent') then
        player.component("numeric_bar", "LuaComponent", "script_source_file", "data/scripts/bars/numeric_bar.lua")
        player.component("numeric_bar", "LuaComponent", "execute_every_n_frame", "1")
    end
end

function player_num_disable()
    EntityRemoveComponent(player.id(), EntityGetFirstComponent(player.id(), 'SpriteComponent', 'numeric_bar'))
end

function enemy_bar_enable()
    -- отрисовка здоровья для мобов
    local enemies = Z:Entity("enemy")
    for i, enemy in ipairs(enemies) do
        if EntityGetName(enemy.id()) ~= '$animal_pebble' then
            if HasFlagPersistent('hp_enemy_bar') then
                enemy.component("sprite_bar", "LuaComponent", "script_source_file", "data/scripts/bars/sprite_bar.lua")
                enemy.component("sprite_bar", "LuaComponent", "execute_every_n_frame", "1")
            end
        end
    end
end

function enemy_bar_disable()
    -- отрисовка здоровья для мобов
    local enemies = Z:Entity("enemy")
    for i, enemy in ipairs(enemies) do
        if EntityGetName(enemy.id()) ~= '$animal_pebble' then
            EntityRemoveComponent(enemy.id(), EntityGetFirstComponent(enemy.id(), 'HealthBarComponent'))
            EntityRemoveComponent(enemy.id(), EntityGetFirstComponent(enemy.id(), 'SpriteComponent', 'health_bar'))
            EntityRemoveComponent(enemy.id(), EntityGetFirstComponent(enemy.id(), 'SpriteComponent', 'health_bar_bg'))
            EntityRemoveComponent(enemy.id(), EntityGetFirstComponent(enemy.id(), 'LuaComponent', 'sprite_bar'))
        end
    end
end

function enemy_num_enable()
    local enemies = Z:Entity("enemy")
    for i, enemy in ipairs(enemies) do
        if EntityGetName(enemy.id()) ~= '$animal_pebble' and EntityHasTag(enemy.id(), 'worm') == false then
           if HasFlagPersistent('hp_enemy_num') or HasFlagPersistent('hp_enemy_percent') then
                enemy.component("numeric_bar", "LuaComponent", "script_source_file", "data/scripts/bars/numeric_bar.lua")
                enemy.component("numeric_bar", "LuaComponent", "execute_every_n_frame", "1")
            end
        end
    end
end

function enemy_num_disable()
    local enemies = Z:Entity("enemy")
    for i, enemy in ipairs(enemies) do
        if EntityGetName(enemy.id()) ~= '$animal_pebble' and EntityHasTag(enemy.id(), 'worm') == false then
            local component = EntityGetFirstComponent(enemy.id(), 'SpriteComponent', 'numeric_bar')
            if component then
                EntityRemoveComponent(enemy.id(), component)
            end
        end
    end
end