dofile ("data/zero/zero.lua")

function clear(gui)
    -- Очищает интерфейс перед новой отрисовкой
    local ui = Z:GUI()
    for i = 1, 80 do
        ui.sprite(gui, nil, 0, 0, "gui_health_fg", i)
    end
    ui.sprite(gui, nil, 0, 0, "gui_health")
    ui.sprite(gui, nil, 0, 0, "gui_other_energy")
    ui.sprite(gui, nil, 0, 0, "gui_other_mana")
end

function gui_loop(gui)
    local ui = Z:GUI()
    local storage = Z:Storage()
    local player = Z:Entity("player_unit")[1]

    -- расчитывает лимит, т.е. значение для цикла
    local max_hp = player.max_hp()
    local hp = player.hp()
    local one_part = max_hp / 80
    local limit = Z:Utils().round(hp / one_part)

    -- проверяем, находится ли игрок под водой
    local component = EntityGetFirstComponent(player.id(), "DamageModelComponent")
    local water = tonumber(ComponentGetValue(component, "air_in_lungs"))

    local is_water = storage.data('hb', 'is_water')

    -- нужно для правильной отрисовки при погруждении под воду
    if water < 7 then
        if is_water == 'false' then
            storage.data('hb', 'is_water', 'true')
            clear(gui)
        end
        healt_bar_y = -56
        energy_bar_y = -76
        mana_bar_y = -92
    else
        if is_water == 'true' then
            storage.data('hb', 'is_water', 'false')
            clear(gui)
        end
        healt_bar_y = -40
        energy_bar_y = -60
        mana_bar_y = -76
    end

    -- отрисовка задников баров
    ui.sprite(gui, "data/gui/bar_bg.png", -1116, healt_bar_y, "gui_health")
    ui.sprite(gui, "data/gui/bar_bg_other.png", -1116, energy_bar_y, "gui_other_energy")
    ui.sprite(gui, "data/gui/bar_bg_other.png", -1116, mana_bar_y, "gui_other_mana")
    -- отрисовка hp полоски
    for i = 1, limit do
        ui.sprite(gui, "data/gui/bar_fg.png", -1118 - i, healt_bar_y - 2, "gui_health_fg", i)
    end

    -- очистка от полосок, если hp уменьшается
    for i = limit, 80 do
        ui.sprite(gui, nil, 0, 0, "gui_health_fg", i)
    end
end