--[[

Обработка переодически выполняемых заданий.

Использование:

  event = Z:Event(path)
  event.loop(framerate)

  path - путь к файлу, который будет выполняться
  framerate - частота обновления фреймов. 60 фреймов == 1 секунде

--]]

function Z:Event(file)
  local obj = {}
  local file = file

  local entity_id = EntityCreateNew()
  function obj.loop(timer)
    EntityAddComponent(entity_id, "LuaComponent", {
      script_source_file=file,
      enable_coroutines="1",
      execute_on_added="1",
      execute_times="0",
      execute_every_n_frame=timer,
    });
  end

  function obj.gui_loop()
    storage = Z:Storage()
    storage.data("noita_rpg","gui_loop", file)
    EntityLoad("data/zero/event.xml")
  end

  setmetatable(obj, self)
  self.__index = self 
  return obj
end