--[[

Отрисовка графических элементов на экран.

--]]

if not async then
	dofile( "data/scripts/lib/coroutines.lua" )
end
dofile( "data/scripts/lib/utilities.lua" )

function Z:GUI(file)
  local obj = {}
  --local gui = GuiCreate()
  --GuiStartFrame(gui)

  -- Выводит текст
  function obj.text(gui, x, y, x2, y2, text)
    GuiLayoutBeginVertical(gui, x, y)
    GuiTextCentered(gui, x2, y2, text)
    GuiLayoutEnd(gui)
  end

  -- Выводит кнопку
  function obj.button(gui, x, y, x2, y2, text, id)
    GuiLayoutBeginVertical(gui, x, y)
    local status = GuiButton(gui, x2, y2, text, id)
    GuiLayoutEnd(gui)
    return status
  end

  -- Выводит текст с шрифтом font
  function obj.text_cf(font, x, y, tag, text)
    local entities = EntityGetWithTag(tag)[1]
    if entities == nil then
      local entity = EntityCreateNew()
      EntityAddComponent(entity, "SpriteComponent", 
      {
        image_file = font,
        _tags = tag,
        has_special_scale="1",
        is_text_sprite="1",
        offset_x = x,
        offset_y = y,
        special_scale_x = "2",
        special_scale_y = "2",
        ui_is_parent= "1",
        update_transform= "1",
        text=text,
      });
      EntityAddTag(entity, tag)
    else
      local component = EntityGetFirstComponent(entities, "SpriteComponent", tag)
      local value = ComponentGetValue(component, "text", text)
      value = tostring(value)
      text = tostring(text)
      if value ~= text then
        EntityKill(entities)
      end
    end
  end

  -- Выводит спрайтовое изображение
  function obj.sprite(gui, file, x, y, tag, id)
    if id == nil then
      id = 1
    end
    if file then 
      local entities = EntityGetWithTag(tag)[id]
      if entities == nil then
        local entity = EntityCreateNew()
        EntityAddComponent(entity, "SpriteComponent", 
        {
          image_file = file,
          ui_is_parent = "1",
          offset_x = x,
          offset_y = y,
          z_index = -10,
        });
        EntityAddTag(entity, tag)
      end
    else
      local entities = EntityGetWithTag(tag)
      if entities[1] ~= nil then
        EntityKill(entities[id])
      end
    end
  end


  setmetatable(obj, self)
  self.__index = self 
  return obj
end

