--[[ 

Обработка хранимых значений для внутренних нужд.
Позволяет хранить значения даже после перезагрузки игры.

Использование:

  storage = Z:Storage()
  storage.data(key1, key2, [value])

  key1, key2 - ключи для доступа
  value - если есть, то устанавливает значение, если нет, то возвращает значени

--]]

function Z:Storage()
  local obj = {}

  -- Сохранить или получить значение
  function obj.data(key1, key2, value)

    -- получить сущность игрока
    local enetity_id = EntityGetWithTag("player_unit")[1]
    local key = key1 .. "_" .. key2
    local component = EntityGetFirstComponent(enetity_id, "SpriteComponent", key)

    if value then
      if component == nil then
        EntityAddComponent(enetity_id, "SpriteComponent", 
        {
          _tags = key,
          is_text_sprite ="1", 
          visible = "0", 
          text = value,
        })
      else
        ComponentSetValue(component, "text", value)
      end
    else
      return ComponentGetValue (component, "text")
    end

  end
  setmetatable(obj, self)
  self.__index = self 
  return obj
end